/*
	BetaWorld (OASIS project)
	2001 Igor Rudym
	A-Games(C)
*/

#include <stdio.h>
#include <allegro.h>
#include <allegttf.h>


//my libs
#include "lua-script/betascript.h"


#include "system/init.h"
//#include "system/global.h"

#include "map/map.h"
#include "gui/gui.h"
#include "scene/scene.h"
//#include "script/myscript.h"
#include "objects/object.h"
#include "objects/frameobject.h"
#include "world/world.h"


#include "fx/rain.h"



BITMAP *buffer;
	
BITMAP *cursor = NULL;


int fps=0,frame_count=0;
int max_fps = 0,min_fps = 0xffff;
int num=0;
//int max_num = 11;
int old_num = -1;


void fps_proc(void)
{
   fps = frame_count;
   if(fps > max_fps) max_fps = fps;
   if(fps < min_fps && fps!=0) min_fps = fps;
   frame_count = 0;
}
END_OF_FUNCTION(fps_proc);


void anim_timer(void)
{
	num++;
}
END_OF_FUNCTION(anim_timer);

//if size of texture 64x64 - polygon be 90x44
                                        

/*
void show_image(BITMAP *buffer,BITMAP *bmp,int num,int size,int x,int y)
{
	masked_blit(bmp,buffer,num*size,0,x,y,size,size);
}
*/ 


DIALOG the_dialog[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)                    (d2)  (dp)              (dp2) (dp3) */
   { d_clear_proc,      0,    0,      0,   0,    255,  0,    0,    0,       0,                      0,    NULL,             NULL, NULL  },
   { d_button_proc,     80, 400,    161,  49,   255,  0,    0,    D_EXIT | D_DIRTY,  0,                      0,    (void*)"OK",             NULL, NULL  },
   { d_bitmap_proc,		0,	  0,	640, 480,	0,    0,    0,    D_DIRTY,       0,                      0,    (void*)buffer,           NULL, NULL  },
   { NULL,              0,    0,    0,    0,    0,    0,    0,    0,       0,                      0,    NULL,             NULL, NULL  }
};




int main(int argc, char **argv)
{
	//init_system();

	luaBetaScript *init_script = new luaBetaScript("data/scripts/init.bas");

	//init_script->parser();
	//init_script->Run();


	text_mode(-1);

    LOCK_VARIABLE(frame_count);
   	LOCK_VARIABLE(fps);
   	LOCK_FUNCTION(fps_proc);
    install_int(fps_proc, 1000);

	LOCK_FUNCTION(anim_timer);
    install_int(anim_timer, 80);


	BITMAP *load_title = LoadBitmap("data/gfx/loading.bmp");
	draw_sprite(screen,load_title,0,0);
	destroy_bitmap(load_title);

    
	BITMAP *cur;
	BITMAP* cursor1 = LoadBitmap("data/cursors/cursorup.bmp");
	BITMAP* cursor2 = LoadBitmap("data/cursors/cursordown.bmp");
	BITMAP* panel_r = LoadBitmap("data/gfx/right.bmp");	


	buffer = create_bitmap(GFX_SX,GFX_SY);
	if(buffer==NULL) {
		allegro_exit();
		printf("\nERROR:can't allocate memory for buffer!\n");
		return 1;
	}

	//BITMAP *fon = LoadBitmap("data/gfx/items/potion1.bmp");

	FONT* thefont_15point;
	thefont_15point = load_ttf_font("data/fonts/dom.ttf",15,ALLEGTTF_REALSMOOTH);
	if(thefont_15point == NULL) {
		allegro_exit();
		printf("Could not load ttf dom.ttf [15 point]\n");
      	exit(1);
    }

   	
	set_luminance_blender(50,50,50,70);


	Logger::Log("Create map...\n");
	IObject *map = new CMap();

	//((CMap*)map)->TestInit();
	map->Load("data/world/DownTown/map/downtown.map");
	

	((CMap*)map)->SetCoords();


	map->SetScreen(buffer);

	
	//((CMap*)map)->Save("test.map");

	int i,j;
	int map_x,map_y;

	char name[64];
	strcpy(name,"empty");
	
	Logger::Log("Create scene...");
	CScene *myscene = new CScene();
	Logger::Log("OK\n");

	Logger::Log("Add map to scene...");
	myscene->Add(map);
	Logger::Log("OK\n");
	

	Logger::Log("Load scene...\n");
	myscene->Load("data/world/DownTown/scene.bas");
	Logger::Log("OK\n");

	

	Logger::Log("SetUp object on scene...");
	myscene->SetUpObjectsOnScene();
	Logger::Log("OK\n");
	
	IObject* rain = new CRain();
	rain->SetXY(10,10);
	rain->SetSizes(600,400);

	myscene->Add(rain);
	

	myscene->SetScreen(buffer);
	

	World *BetaWorld = new World();
	BetaWorld->SetScene(myscene);


	IObject *curpos = myscene->Get("curpos");
	if(curpos == NULL) {
		printf("ERROR: can't find object: curpos!\n");
		allegro_exit();
		return 7;
	}

	
	
	Logger::Log("Start MAIN CYCLE!\n");
	//main cycle

	((Object*)curpos)->SetIJ(1,1);

	//the_dialog[2].dp = (void*)buffer;
	//DIALOG_PLAYER *player = init_dialog(the_dialog,-1);

	int ret_dlg;
	//acquire_bitmap(buffer);
	while(1) {
		
		cur = cursor;

		clear(buffer);
		//release_bitmap(buffer);
		
		if(key[KEY_ESC]) break;

		if(key[KEY_LEFT]) BetaWorld->GetCurrentScene()->Move(5,0);
		if(key[KEY_RIGHT]) BetaWorld->GetCurrentScene()->Move(-5,0);
		if(key[KEY_UP]) BetaWorld->GetCurrentScene()->Move(0,5);
		if(key[KEY_DOWN]) BetaWorld->GetCurrentScene()->Move(0,-5);
		
		if(key[KEY_ENTER] && key[KEY_ALT]) {
			if(mode == GFX_DIRECTX_WIN) mode = GFX_AUTODETECT;
				else mode = GFX_DIRECTX_WIN;
			set_gfx_mode(mode, GFX_SX, GFX_SY, 0, 0);
		}

		if(mouse_y<5) {
			cur = cursor1;
			BetaWorld->GetCurrentScene()->Move(0,5);
		}
		if(mouse_y>480-cursor2->h) {
			cur = cursor2;
			BetaWorld->GetCurrentScene()->Move(0,-5);
			mouse_y=480-cursor2->h+1;
		}

		((CMap*)map)->UnSelect();
		((CMap*)map)->GetMapCoord(mouse_x,mouse_y,&i,&j);
		((CMap*)map)->Select(i,j);
		

		map->GetXY(&map_x,&map_y);

        //acquire_bitmap(buffer);

		//printf("MAIN::Select object...");
		myscene->SelectObject(mouse_x,mouse_y);
		//printf("OK!\n");

		set_clip(buffer,10,10,560,380);
		
		//printf("MAIN::Show scene\n");
		myscene->Show();
		//printf("OK!\n");
		//printf("MAIN::Live scene\n");
		myscene->Live();
		//printf("OK!\n");

        set_clip(buffer,0,0,640,480);

		//draw_sprite(buffer,fon,200,200);


		if(mouse_b & 2) {
			strcpy(name,((CMap*)map)->GetTerraName(i,j));
			((CFrameObject*)curpos)->SetFrame(0);
			((Object*)curpos)->SetIJ(i,j);
			((Object*)curpos)->UnSetFlag(OBJ_NONVISIBLE);
		}
		
		rectfill(buffer,10,410,500,470,makecol(0,0,0));

        aatextprintf(buffer, thefont_15point, 10,410, makecol(255,255,255),"GFX Mode: %ix%i",GFX_SX,GFX_SY);
	    aatextprintf(buffer, thefont_15point, 10,430, makecol(255,255,255),"FPS: %d",fps);    
	

		aatextprintf(buffer, thefont_15point, 10,10, makecol(255,255,255),"Mouse:    (%d,%d)",mouse_x,mouse_y);
		aatextprintf(buffer, thefont_15point, 10,30, makecol(255,255,255),"Selected: (%d,%d)",i,j);
		aatextprintf(buffer, thefont_15point, 10,50, makecol(255,255,255),"Terra name: %s",name);
		aatextprintf(buffer, thefont_15point, 10,70, makecol(255,255,255),"Map (x,y): (%d,%d)",map_x,map_y);

		aatextprintf(buffer, thefont_15point, 10,450, makecol(255,55,255),"BetaWorld Engine v 1.8    A-Games(C)   "); 

		if(!((CMap*)map)->GetFreeStatus(i,j)) 
			aatextprintf(buffer, thefont_15point, 10,90, makecol(255,255,255),"The cell(%d,%d) is not FREE!",i,j);

		
		draw_sprite(buffer,panel_r,640-146,0);

		//draw cursor
		draw_sprite(buffer,cur,mouse_x,mouse_y);
		//acquire_screen();
		blit(buffer, screen, 0, 0, 0, 0, GFX_SX, GFX_SY);
        //release_screen();
        frame_count++;
        //vsync();
		//animation block

		if(old_num!=num) {
			//printf("MAIN::Animation scene...");
			myscene->Animation();
			//printf("OK!\n");
			old_num = num;
		}
		//vsync();
		//dialog_message(the_dialog,MSG_DRAW,0,&ret_dlg);
        //update_dialog(player);

		
	}

	//shutdown_dialog(player);

	Logger::Log("Delete world...");
	delete BetaWorld;
	Logger::Log("OK\n");
	Logger::Log("OK\nDeinit system...");
	deinit_system();
	Logger::Log("OK\n");
	char buf[264];
	sprintf(buf,"Max fps: %d\nMin fps: %d\n",max_fps,min_fps);
	Logger::Log(buf);
	return 0;
}

END_OF_MAIN();
