//RAIN FX

#include <allegro.h>

#include "../objects/common.h"

#include <conio.h>
#include <stdio.h>


class CRain : public CommonObject {
public:
	struct RainDrop {
		float x1,y1;
		float x2,y2;
		float vel;
		int time_die;
		int live_time;
		int col;
	};

	CRain():CommonObject() {
		InitRain();
		SetFlag(OBJ_NONSELECT);
		printf("RAIN::CRain()\n"); 
	}
	
	virtual ~CRain() {
		printf("RAIN::CRain()\n");
		if(rain!=NULL) delete[] rain;
	}

	void InitRain() {
		SetName("RAIN_FX");
		rain = new RainDrop[200];
		for(int i=0;i<200;i++) {
			rain[i].x1 = rand()%600;
			rain[i].y1 = rand()%400;
			rain[i].x2 = rain[i].x1-2;
			rain[i].y2 = rain[i].y1+8;
			rain[i].vel = 6;
			rain[i].live_time = rand()%50+10;
			rain[i].col = makecol(190,190,195);
		}
		wind=1;
	}

	virtual void Move(int i_x,int i_y) {
		for(int i=0;i<200;i++) {
			rain[i].x1+=i_x;
			rain[i].x2+=i_x;
			rain[i].y1+=i_y;
			rain[i].y2+=i_y;
		}
	}

	virtual int Show() {
		Animation();
		printf("RAIN: Show()!\n");
		for(int i=0;i<180;i++) {
			if(rain[i].live_time<0 || rain[i].y2>y+size_j) {
				circle(p_screen,(int)rain[i].x2,(int)rain[i].y2,2,rain[i].col);
				rain[i].x1 = rand()%size_i+x+100-100;
				rain[i].y1 = rand()%size_j-80;
				rain[i].x2 = rain[i].x1+wind*2;
				rain[i].y2 = rain[i].y1+10;
				rain[i].vel = 8;
				rain[i].live_time = rand()%40+1;
				int col = 100+rand()%100;
				rain[i].col = makecol(col,col,col);
			}
			line(p_screen,(int)rain[i].x1,(int)rain[i].y1,
				(int)rain[i].x2,(int)rain[i].y2,rain[i].col);
		}
		return 0;
	}


	virtual int Animation() {
		for(int i=0;i<180;i++) {
			rain[i].live_time--;
			rain[i].x1+=wind;
			rain[i].x2+=wind;
			rain[i].y1+=rain[i].vel;
			rain[i].y2+=rain[i].vel;
		}
		return 0;
	}

	virtual int Load(char*) {return 0;}
	virtual int Save(char*) {return 0;}
	virtual int Live() {return 0;}
	virtual int GetZ() {return 1000;}
	virtual void GetSizes(int *px,int *py) {
		*px = size_i;
		*py = size_j;
	}
	virtual int GetType() {
		printf("RAIN: GetType()!\n");
		return OBJ_FX;
	}


private:
	RainDrop *rain;
	int wind;
};


