/*
	Script based on LUA
	BetaWorld v 0.x
	Igor Rudym (C) A-GAMES!
*/

#include "betascript.h"


extern int init_system(void);
extern int set_gfx(int,int); 
extern BITMAP * LoadBitmap(char *filename);


        

luaBetaScript::luaBetaScript():luaScript()
{
}

luaBetaScript::luaBetaScript(char *filename):luaScript()
{
	init_funcs();
	lua_dofile(lp_L,filename);
	lua_close(lp_L);
	lp_L = NULL;
}



luaBetaScript::~luaBetaScript()
{
}

void luaBetaScript::init_funcs()
{
	lua_register(lp_L,"set_gfx",set_gfx);
	lua_register(lp_L,"set_windowed",set_windowed);
	lua_register(lp_L,"set_cursor",set_cursor);
	lua_register(lp_L,"init",init);	
}


int luaBetaScript::set_gfx(lua_State *L)
{
	int n=lua_gettop(L);
	int sx = (int)lua_tonumber(L,1);
	int sy = (int)lua_tonumber(L,2);
	::set_gfx(sx,sy);	
	return 0;
}

int luaBetaScript::set_windowed(lua_State *L)
{
	int n=lua_gettop(L);
	if((int)lua_tonumber(L,1)==1) mode = GFX_DIRECTX_WIN;
		else mode = GFX_AUTODETECT;
	return 0;
}

int luaBetaScript::set_cursor(lua_State *L)
{            
	int n = lua_gettop(L);
	cursor = LoadBitmap((char*)lua_tostring(L,2));
	if(cursor==NULL) return 1;      
	return 0;
}

int luaBetaScript::init(lua_State *L)
{
	::init_system();
	return 0;
}

