/*
	BetaWorld v 0.1.8
	lua common Script
*/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "luascript.h"



luaScript::luaScript()
{
	lp_L = lua_open(0);
	lua_register(lp_L,"print",print);
	//lua_register(lp_L,"strcat",my_strcat);
	lua_register(lp_L,"srand",lua_srand);
	lua_register(lp_L,"rand",lua_rand);
	lua_register(lp_L,"include",lua_include);
}


luaScript::~luaScript()
{
	if(lp_L!=NULL) lua_close(lp_L);
}
	

void luaScript::lua_addFun(const char *fun_name,const lua_CFunction fun)
{	
	lua_register(lp_L,fun_name,fun);
}


int luaScript::print(lua_State *L)
{
 int n=lua_gettop(L);
 int i;
 for (i=1; i<=n; i++)
 {
  if (i>1) printf("\t");
  if (lua_isstring(L,i))
   printf("%s",lua_tostring(L,i));
  else
   printf("%s:%p",lua_typename(L,lua_type(L,i)),lua_topointer(L,i));
 }
 printf("\n");
 return 0;
}

/*
int luaScript::my_strcat(lua_State *L)
{
	int n=lua_gettop(L);
	char *str = new char[strlen(lua_tostring(L,1))+strlen(lua_tostring(L,2))+1];
	strcpy(str,lua_tostring(L,1));
	strcat(str,lua_tostring(L,2));

	lua_pushstring(L,str);
	delete[] str;

	return 1;
}
*/


int luaScript::lua_srand(lua_State *L)
{
	int n = lua_gettop(L);
	srand((int)lua_tonumber(L,1)+time(0));
	return 0;
}

int luaScript::lua_rand(lua_State *L)
{
	int n = lua_gettop(L);
	int num = rand()%(int)lua_tonumber(L,1);
	lua_pushnumber(L,num);
	return 1;
}

int luaScript::lua_include(lua_State *L)
{
	int n = lua_gettop(L);
	lua_dofile(L,lua_tostring(L,1));
	return 0;
}