#ifndef __MAP_H
#define __MAP_H

#include "../interfaces/imap.h"
#include "../tools/imglib.h"
#include "../tools/tools.h"
#include "../system/global.h"
#include "../objects/common.h"

#include "terra.h"



#include <allegro.h>


#define TERRA_SX   90
#define TERRA_SY   44
#define TERRA_SX_2 45
#define TERRA_SY_2 22



typedef struct MAP {
	int type;
	int x,y;
	bool selected;
	bool is_free;    //,      .
	
    MAP():selected(false),is_free(true) {}
};
	
typedef struct MAPHeader {
	char name[64];
	int version;
	int size_i,size_j;
	int textures;
}; 




class CMap : public CommonObject {
public:
	CMap(void);
	virtual ~CMap();

    virtual int Load(char *filename);
	virtual int Save(char *filename);

	virtual int Live();

	virtual int Show();

    virtual void Move(int x,int y);
	virtual void SetXY(int x,int y);
	virtual void GetXY(int*, int*);
	virtual int GetZ();

	virtual void GetSizeIJ(int *pi_size_i,int *pi_size_j);

	virtual void GenerateTextures(char *filename,char *name);

	virtual void GetMapCoord(int x,int y,int *pi,int *pj);

	void TestInit();

	void UnSelect();
	void Select(int i,int j);

	char* GetTerraName(int i,int j);

	virtual void SetCoords(); 

	virtual void GetSizes(int *, int *);

	virtual bool GetFreeStatus(int i,int j); //,   
	virtual void SetFreeStatus(int i,int j,bool stat);


	void SaveDigRomb() {
		if(dig_romb==NULL) return;
		FILE *f = fopen("romb.dig","w");
		for(int i=0;i<terra->Get(0)->h;i++) {
			fprintf(f,"%d: %d,%d\n",i,dig_romb[i].offset,dig_romb[i].len);
		}
		fclose(f);
	}


	virtual int GetType() {return OBJ_MAP;}

	void setup_lightmap(int li,int lj);

	virtual int Animation() {return 0;}


	void Finalize();   //  ,  !!!!

private:

	MAP m_map[100][100];
	int i,j;
	int sel_i,sel_j;
	//int size_i,size_j;
	int map_x,map_y;
	//BITMAP *buffer;

	CImgLib *terra;
	BITMAP *romb;
	CTerra::TRomb *dig_romb;
	BITMAP *color_mask;
	CImgLib* imgs_2d;     //2D  
};


#endif