#include "terra.h"

#include <math.h>






BITMAP* CTerra::Image(char *filename) 
{
	BITMAP *tmp = LoadBitmap(filename);
	BITMAP *terra = makeromb(tmp);
	destroy_bitmap(tmp);
	return terra;
}

BITMAP* CTerra::Image(BITMAP *bmp)
{
	BITMAP *terra = makeromb(bmp);
	return terra;
}

BITMAP* CTerra::Romb(int sx,int sy,int col)
{
	BITMAP *tmp = create_bitmap(sx,sy);
	clear_to_color(tmp,makecol(255,0,255));
	sx--;
	sy--;

	line(tmp,0,sy/2,sx/2,0,col);
	line(tmp,sx/2,0,sx,sy/2,col);
	line(tmp,sx,sy/2,sx/2,sy,col);
	line(tmp,sx/2,sy,0,sy/2,col);

	return tmp;
}

BITMAP* CTerra::makeromb(BITMAP *texture)
{
	int i;
	
	BITMAP *tmp = create_bitmap(91,45);
	if(tmp==NULL) {
		printf("ERROR: can't create temp bitmap!\n");
		allegro_exit(); 
		exit(45);
	}
	//printf("------>clear to color...");
	clear_to_color(tmp,makecol(255,0,255));
	//printf("OK!\n");
	V3D v[4];
		//V3D vout[4];
	v[0].x = ftofix(-32);v[0].y = ftofix(32);v[0].z = 0;v[0].u=0;v[0].v=63<<16;
	v[1].x = ftofix(32);v[1].y = ftofix(32);v[1].z = 0;v[1].u=63<<16;v[1].v=63<<16;
	v[2].x = ftofix(32);v[2].y = ftofix(-32);v[2].z = 0;v[2].u=63<<16;v[2].v=0;
	v[3].x = ftofix(-32);v[3].y =ftofix(-32);v[3].z = 0;v[3].u=0;v[3].v=0;

	MATRIX matrix;
	    
	get_rotation_matrix(&matrix, ftofix(42.6666), 0, ftofix(32));
	for(i=0;i<4;i++) 
		apply_matrix(&matrix, v[i].x, v[i].y, v[i].z, &v[i].x, &v[i].y, &v[i].z);
	get_translation_matrix(&matrix, ftofix(45), ftofix(22),0);
	for(i=0;i<4;i++) 
		apply_matrix(&matrix, v[i].x, v[i].y, v[i].z, &v[i].x, &v[i].y, &v[i].z);
    
	//printf("------> render...");
	quad3d(tmp, POLYTYPE_ATEX, texture, &v[0],&v[1],&v[2],&v[3]);
	//printf("OK!\n");
	return tmp;
}

CTerra::TRomb* CTerra::GetDigRomb(BITMAP *romb) {
	CTerra::TRomb *ret = new CTerra::TRomb[romb->h];

	int i,j,c;
	for(j=0;j<romb->h;j++) 
	{
		for(i=0;i<romb->w;i++) {
			//printf("--->GetDigRomb: i:%d  j:%d  pixel: %d (%d)\n",
			//		i,j,getpixel(romb,i,j),makecol(255,0,255));
			if(getpixel(romb,i,j)!=makecol(255,0,255)) {
				//printf("--->GetDigRomb: found start in: %d\n",i);
				ret[j].offset = i;
				for(c=i;c<romb->w;c++) {
					//printf("---->C: %d\n",c);
					if(getpixel(romb,c,j)==makecol(255,0,255)) {
						//printf("--->Size: %d\n",c-i-1);
						ret[j].len = c-i-1;
						i = romb->w;
						break;
					}	
				}
				if(c==romb->w) {
					ret[j].len = romb->w-1;
					break;
				}
			}
		}
	}
	return ret; 
}

void CTerra::draw_dig_romb(BITMAP *dest,BITMAP *bmp,CTerra::TRomb *dig,int x,int y)
{
	short *sline,*bline;
	int sx,bx; 
	int len;
	int start=0;
	int end=bmp->h;
	
	int dw = dest->w,dh=dest->h;
	int dsx = 0,dsy = 0;
	//int 
	if(dest->clip) {
		dw = dest->cr;
		dh = dest->cb;
		dsx = dest->cl;
		dsy = dest->ct;
	}
    if(y<dsy) start =dsy-y;
	if(y>dh-bmp->h) end=dh-y;
	for(int j=start;j<end;j++) {
		sx = x+dig[j].offset;
		bx = dig[j].offset;
		len = dig[j].len;
		//if out left of screen
		if(sx<dsx) {
			if(sx+dig[j].len<dsx) continue;
			bx-=sx-dsx;
			len+=sx-dsx;
			sx = dsx;
		}
		//if out right of screen
		if(sx>dw-bmp->w) {
			if(sx>=dw) continue;
			len=dw - sx;	
		}
		sline = &(((short*)dest->line[y+j])[sx]);
		bline = &(((short*)bmp->line[j])[bx]);
		memcpy(sline,bline,len*2);
	}
}
	
BITMAP* CTerra::create4color_mask(BITMAP*bmp)
{
	int cred = makecol(255,0,0);
	int cgreen = makecol(0,255,0);
	int cblue = makecol(0,0,255);
	int cblack = makecol(0,0,0);
	int cyellow = makecol(255,255,0);

	BITMAP *ret = create_bitmap(bmp->w,bmp->h);

	rectfill(ret,0,0,ret->w/2,ret->h/2,cred);
	rectfill(ret,ret->w/2,0,ret->w,ret->h/2,cgreen);
	rectfill(ret,0,ret->h/2,ret->w/2,ret->h,cblue);
	rectfill(ret,ret->w/2,ret->h/2,ret->w,ret->h,cyellow);

	for(int j=0;j<bmp->h;j++)
		for(int i=0;i<bmp->w;i++)
			if(getpixel(bmp,i,j)!=makecol(255,0,255)) putpixel(ret,i,j,cblack);
	return ret;	
}

BITMAP* CTerra::make_light_texture(BITMAP *bmp,int r,int g,int b,int a,int tx,int ty,int lx,int ly)
{
	BITMAP *ret = create_bitmap(bmp->w,bmp->h);
	int i,j;
	int nr,ng,nb;
	int color;
	int light;
	int dest;
	for(j=0;j<ret->h;j++)
		for(i=0;i<ret->w;i++) {
			color = ((short*)bmp->line[j])[i];
			dest = (int)sqrt(pow(i+tx-lx,2)+pow(j+ty-ly,2));
			if(dest>255) dest=255;
			light = 255 - dest;
			if(light<0) light = 0;
			nr = ((a+light)*(r+getr(color))>>8)+getr(color);
			ng = ((a+light)*(g+getg(color))>>8)+getg(color);
			nb = ((a+light)*(b+getb(color))>>8)+getb(color);
			if(nr>255) nr=255;
			if(ng>255) ng=255;
			if(nb>255) nb=255;

			((short*)ret->line[j])[i] = makecol(nr,ng,nb);
		
	}
	return ret;

}

BITMAP* CTerra::make_light_romb(BITMAP *bmp,int r,int g,int b,int a,int tx,int ty,int lx,int ly)
{
	//printf("----> make light texture...");
	BITMAP *lt = make_light_texture(bmp,r,g,b,a,tx,ty,lx,ly);
	if(lt==NULL) {
		printf("\nERROR: can't make light texture!\n");
		allegro_exit();
		exit(56);
	}
	//printf("OK!\n----> make romb...");
	BITMAP *ret = Image(lt);
	//draw_sprite(screen,ret,10,80);
	//printf("OK!\n----> destroy temp...");
	destroy_bitmap(lt);
	//printf("OK!\n");
	return ret;
}

