/*

		Map Editor v 1.20
		for BetaWorld Project


		A-Games (C) Igor Rudym 1999-2001

*/

#include <allegro.h>

#include "MapEditor/emap.h"
#include "System/init.h"
#include "gui/gui.h"

BITMAP *cursor;
BITMAP *buffer;



void DrawBorder(BITMAP *bmp,int x,int y,int x1,int y1)
{
	rect(bmp,x,y,x1-1,y1-1,makecol(255,255,255));
	rect(bmp,x+1,y+1,x1,y1,makecol(55,55,55));
}

void DrawSquares(BITMAP *bmp,int x,int y,int size,int si,int sj)
{
	for(int i=0;i<si;i++) {
		line(bmp,i*size+x,y,i*size+x,y+(sj-1)*(size),makecol(100,100,100));
	}
	for(int i=0;i<sj;i++) {
		line(bmp,x,i*size+y,x+(size-2)*si,i*size+y,makecol(100,100,100));
	}
}


void DrawGrid(BITMAP *bmp)
{
	DrawBorder(bmp,1,40,486,460);	
	rectfill(bmp,3,42,483,459,makecol(255,255,255));

	DrawSquares(bmp,3,42,32,16,14);
}







int main(int argc, char **argv)
{

	init_system();
    cursor = LoadBitmap("data/cursors/cursor1.bmp");
	BITMAP *buffer = create_bitmap(GFX_SX,GFX_SY);

	EditMap *map = new EditMap();
	map->SetScreen(buffer);


	while(1) {
		clear_to_color(buffer,makecol(155,155,155));
	 	if(key[KEY_ESC]) break;

	 	DrawGrid(buffer);

        draw_sprite(buffer,cursor,mouse_x,mouse_y);
		blit(buffer, screen, 0, 0, 0, 0, GFX_SX, GFX_SY);
	}


	delete map;
    deinit_system();
	return 0;
}

END_OF_MAIN();
