#ifndef __COMMON_H
#define __COMMON_H

#include <allegro.h>
#include <string.h>

#include "../system/log.h"


#define OBJ_BLENDING 	1
#define OBJ_NONSELECT   2
#define OBJ_NONVISIBLE	4


//Common for all objects
class CommonObject : public IObject {
public:

	CommonObject():name(NULL),FLAG(0) {}
	
	virtual ~CommonObject() {
		//Logger::Log("--->Destroy name...\n");		
		if(name!=NULL) delete[] name;
	}

//-----------------------------------------------------------------------------

	virtual void SetXY(int i_x,int i_y) {
		x = i_x;
		y = i_y;
	}

	virtual void GetXY(int *ip_x,int *ip_y) {
		*ip_x = x;
		*ip_y = y;
	}

	virtual void Move(int i_x,int i_y) {
		x+=i_x;
		y+=i_y;
	}

	virtual void SetSizes(int i_si,int i_sj) {
		size_i = i_si;
		size_j = i_sj;
	}

//-----------------------------------------------------------------------------

	virtual void SetName(char *cp_name) {
		if(name!=NULL) delete name;
		name = new char[strlen(cp_name)+1];
		if(name==NULL) {throw "ERROR! Can't allocate memory for name";}
		strcpy(name,cp_name);
	}

	virtual char* GetName() {
		return name;
	}

//-----------------------------------------------------------------------------

	virtual void SetScreen(BITMAP *bp_screen) {
		p_screen = bp_screen;
	}

//-----------------------------------------------------------------------------
   	virtual int Animation() {return 0;}	


	void SetFlag(int s) {
		FLAG = FLAG | s;
	}

	void UnSetFlag(int s) {
		FLAG = FLAG & !s;
	}

	int GetFlag() {
		return FLAG;
	}

protected:
	int x,y;
	int size_i,size_j;
	char *name;
	BITMAP *p_screen;
	int FLAG;
};



#endif
