

#include "../system/error.h"
#include "creature.h"
#include "task.h"

extern IObject* gp_cur_object;

CCreature::CCreature():CFrameObject()
{
	luaScript::lua_addFun("move_down",lua_move_down);
	luaScript::lua_addFun("move_dleft",lua_move_dleft);
	luaScript::lua_addFun("move_left",lua_move_left);
	luaScript::lua_addFun("move_uleft",lua_move_uleft);
	luaScript::lua_addFun("move_up",lua_move_up);
	luaScript::lua_addFun("move_uright",lua_move_uright);
	luaScript::lua_addFun("move_right",lua_move_right);
	luaScript::lua_addFun("move_dright",lua_move_dright);
}

CCreature::~CCreature()
{
}


int CCreature::MoveDown()
{
	int image_num = images->GetNum("DOWN_GO");
	if(image_num==-1) {	
		beta_error("Can't find animation: DOWN_GO\n");
	}
	int start_i=i;
	int start_j=j;
	if(!tasks.empty()) {
		start_i = LastTask()->end_i;
		start_j = LastTask()->end_j;
	}
	if(start_i-1<0) return -1;
		STask *ptask = new STask;
		ptask->type = TASK_MOVE_DOWN;
		ptask->start_i = start_i;ptask->start_j=start_j;
		ptask->end_i = start_i-1;ptask->end_j = start_j+1;
		if(!CheckFree(ptask)) {
			delete ptask;
			return -2;
		}
		ptask->frame = 0;
		ptask->k1 = 44/images->GetFramesNum(image_num);
		ptask->k2 = 0;
		ptask->image = image_num;
		ptask->end_image = images->GetNum("DOWN_STAND");
		SetTask(ptask);
	
	return 0; 
}

int CCreature::MoveDLeft()
{
	int image_num = images->GetNum("DLEFT_GO");
	if(image_num==-1) {	
		beta_error("Can't find animation: DLEFT_GO\n");
	}
	int start_i=i;
	int start_j=j;
	if(!tasks.empty()) {
		start_i = LastTask()->end_i;
		start_j = LastTask()->end_j;
	}
	if(start_i-1<0) return -1;
		STask *ptask = new STask;
		ptask->type = TASK_MOVE_DLEFT;
		ptask->start_i = start_i;ptask->start_j=start_j;
		ptask->end_i = start_i-1;ptask->end_j = start_j;
		if(!CheckFree(ptask)) {
			delete ptask;
			return -2;
		}
		ptask->frame = 0;
		ptask->k1 = 22/images->GetFramesNum(image_num);  //y
		ptask->k2 = -45/images->GetFramesNum(image_num);  //x
		ptask->image = image_num;
		ptask->end_image = images->GetNum("DLEFT_STAND");
		SetTask(ptask);
	
	return 0; 
}

int CCreature::MoveLeft()
{
	int image_num = images->GetNum("LEFT_GO");
	if(image_num==-1) {	
		beta_error("Can't find animation: LEFT_GO\n");
	}
	int start_i=i;
	int start_j=j;
	if(!tasks.empty()) {
		start_i = LastTask()->end_i;
		start_j = LastTask()->end_j;
	}
	if(start_i-1<0) return -1;
		STask *ptask = new STask;
		ptask->type = TASK_MOVE_LEFT;
		ptask->start_i = start_i;ptask->start_j=start_j;
		ptask->end_i = start_i-1;ptask->end_j = start_j-1;
		if(!CheckFree(ptask)) {
			delete ptask;
			return -2;
		}
		ptask->frame = 0;
		ptask->k1 = 0;
		ptask->k2 = -90/images->GetFramesNum(image_num);
		ptask->image = image_num;
		ptask->end_image = images->GetNum("LEFT_STAND");
		SetTask(ptask);
	
	return 0; 
}

int CCreature::MoveULeft()
{
	int image_num = images->GetNum("ULEFT_GO");
	if(image_num==-1) {	
		beta_error("Can't find animation: ULEFT_GO\n");
	}
	int start_i=i;
	int start_j=j;
	if(!tasks.empty()) {
		start_i = LastTask()->end_i;
		start_j = LastTask()->end_j;
	}
	if(start_i-1<0) return -1;
	if(start_j-1<0) return -1;
		STask *ptask = new STask;
		ptask->type = TASK_MOVE_ULEFT;
		ptask->start_i = start_i;ptask->start_j=start_j;
		ptask->end_i = start_i;ptask->end_j = start_j-1;
		if(!CheckFree(ptask)) {
			delete ptask;
			return -2;
		}
		ptask->frame = 0;
		ptask->k1 = -22/images->GetFramesNum(image_num);
		ptask->k2 = -45/images->GetFramesNum(image_num);
		ptask->image = image_num;
		ptask->end_image = images->GetNum("ULEFT_STAND");
		SetTask(ptask);
	
	return 0; 
}


int CCreature::MoveUp()
{
	int image_num = images->GetNum("UP_GO");
	if(image_num==-1) {	
		beta_error("Can't find animation: UP_GO\n");
	}
	int start_i=i;
	int start_j=j;
	if(!tasks.empty()) {
		start_i = LastTask()->end_i;
		start_j = LastTask()->end_j;
	}
	if(start_i-1<0) return -1;
	if(start_j-1<0) return -1;
		STask *ptask = new STask;
		ptask->type = TASK_MOVE_UP;
		ptask->start_i = start_i;ptask->start_j=start_j;
		ptask->end_i = start_i+1;ptask->end_j = start_j-1;
		if(!CheckFree(ptask)) {
			delete ptask;
			return -2;
		}
		ptask->frame = 0;
		ptask->k1 = -44/images->GetFramesNum(image_num);
		ptask->k2 = 0;
		ptask->image = image_num;
		ptask->end_image = images->GetNum("UP_STAND");
		SetTask(ptask);
	
	return 0; 
}

int CCreature::MoveURight()
{
	int image_num = images->GetNum("URIGHT_GO");
	if(image_num==-1) {	
		beta_error("Can't find animation: URIGHT_GO\n");
	}
	int start_i=i;
	int start_j=j;
	if(!tasks.empty()) {
		start_i = LastTask()->end_i;
		start_j = LastTask()->end_j;
	}
	if(start_i-1<0) return -1;
	if(start_j-1<0) return -1;
		STask *ptask = new STask;
		ptask->type = TASK_MOVE_URIGHT;
		ptask->start_i = start_i;ptask->start_j=start_j;
		ptask->end_i = start_i+1;ptask->end_j = start_j;
		if(!CheckFree(ptask)) {
			delete ptask;
			return -2;
		}
		ptask->frame = 0;
		ptask->k1 = -22/images->GetFramesNum(image_num);
		ptask->k2 = 45/images->GetFramesNum(image_num);
		ptask->image = image_num;
		ptask->end_image = images->GetNum("URIGHT_STAND");
		SetTask(ptask);
	
	return 0; 
}

int CCreature::MoveRight()
{
	int image_num = images->GetNum("RIGHT_GO");
	if(image_num==-1) {	
		beta_error("Can't find animation: RIGHT_GO\n");
	}
	int start_i=i;
	int start_j=j;
	if(!tasks.empty()) {
		start_i = LastTask()->end_i;
		start_j = LastTask()->end_j;
	}
	if(start_i-1<0) return -1;
	if(start_j-1<0) return -1;
		STask *ptask = new STask;
		ptask->type = TASK_MOVE_URIGHT;
		ptask->start_i = start_i;ptask->start_j=start_j;
		ptask->end_i = start_i+1;ptask->end_j = start_j+1;
		if(!CheckFree(ptask)) {
			delete ptask;
			return -2;
		}
		ptask->frame = 0;
		ptask->k1 = 0;
		ptask->k2 = 90/images->GetFramesNum(image_num);
		ptask->image = image_num;
		ptask->end_image = images->GetNum("RIGHT_STAND");
		SetTask(ptask);
	
	return 0; 
}


int CCreature::MoveDRight()
{
	int image_num = images->GetNum("DRIGHT_GO");
	if(image_num==-1) {	
		beta_error("Can't find animation: DRIGHT_GO\n");
	}
	int start_i=i;
	int start_j=j;
	if(!tasks.empty()) {
		start_i = LastTask()->end_i;
		start_j = LastTask()->end_j;
	}
	if(start_i-1<0) return -1;
	if(start_j-1<0) return -1;
		STask *ptask = new STask;
		ptask->type = TASK_MOVE_URIGHT;
		ptask->start_i = start_i;ptask->start_j=start_j;
		ptask->end_i = start_i;ptask->end_j = start_j+1;
		if(!CheckFree(ptask)) {
			delete ptask;
			return -2;
		}
		ptask->frame = 0;
		ptask->k1 = 22/images->GetFramesNum(image_num);
		ptask->k2 = 45/images->GetFramesNum(image_num);
		ptask->image = image_num;
		ptask->end_image = images->GetNum("DRIGHT_STAND");
		SetTask(ptask);
	
	return 0; 
}

bool CCreature::CheckFree(const STask *ptask)
{   
	return ((CMap*)map)->GetFreeStatus(ptask->end_i,ptask->end_j); 
}



int CCreature::Animation()
{
	STask *pt;
	if(!tasks.empty()) {
	    pt = ViewTask();
		current_frame = pt->frame++;
		current_image = pt->image;
		y+=(int)pt->k1;		
		x+=(int)pt->k2;

		if(pt->frame > images->GetFramesNum(current_image)) {
			//printf("TASK: i,j: %d,%d => %d,%d\n",i,j,pt->end_i,pt->end_j);
			((CMap*)map)->SetFreeStatus(i,j,true);
			i = pt->end_i;
			j = pt->end_j;
			((CMap*)map)->SetFreeStatus(i,j,false);
			int tmp_image = pt->end_image;
			//current_image = pt->end_image;
			delete GetTask();
			if(tasks.empty()) current_image = tmp_image;
			SetUpCoords();
		}
	}
	CFrameObject::Animation();
	return 0;
}


//----------------- LUA

int CCreature::lua_move_down(lua_State *L)
{
	int n = lua_gettop(L);
	int steps = (int)lua_tonumber(L,1);
	for(int iter=0;iter<steps;iter++) ((CCreature*)gp_cur_object)->MoveDown();
	return 0;
}

int CCreature::lua_move_dleft(lua_State *L)
{
	int n = lua_gettop(L);
	int steps = (int)lua_tonumber(L,1);
	for(int iter=0;iter<steps;iter++) ((CCreature*)gp_cur_object)->MoveDLeft();
	return 0;
}

int CCreature::lua_move_left(lua_State *L)
{
	int n = lua_gettop(L);
	int steps = (int)lua_tonumber(L,1);
	for(int iter=0;iter<steps;iter++) ((CCreature*)gp_cur_object)->MoveLeft();
	return 0;
}

int CCreature::lua_move_uleft(lua_State *L)
{
	int n = lua_gettop(L);
	int steps = (int)lua_tonumber(L,1);
	for(int iter=0;iter<steps;iter++) ((CCreature*)gp_cur_object)->MoveULeft();
	return 0;
}

int CCreature::lua_move_up(lua_State *L)
{
	int n = lua_gettop(L);
	int steps = (int)lua_tonumber(L,1);
	for(int iter=0;iter<steps;iter++) ((CCreature*)gp_cur_object)->MoveUp();
	return 0;
}

int CCreature::lua_move_uright(lua_State *L)
{
	int n = lua_gettop(L);
	int steps = (int)lua_tonumber(L,1);
	for(int iter=0;iter<steps;iter++) ((CCreature*)gp_cur_object)->MoveURight();
	return 0;
}

int CCreature::lua_move_right(lua_State *L)
{
	int n = lua_gettop(L);
	int steps = (int)lua_tonumber(L,1);
	for(int iter=0;iter<steps;iter++) ((CCreature*)gp_cur_object)->MoveRight();
	return 0;
}

int CCreature::lua_move_dright(lua_State *L)
{
	int n = lua_gettop(L);
	int steps = (int)lua_tonumber(L,1);
	for(int iter=0;iter<steps;iter++) ((CCreature*)gp_cur_object)->MoveDRight();
	return 0;
}


