#include "creature.h"



CFrameObject::CFrameObject():Object(),current_frame(0) 
{
	blend = false;
	luaScript::lua_addFun("get_current_frame",lua_get_current_frame);
}

CFrameObject::~CFrameObject()
{
}


void CFrameObject::SetFrame(int num)
{
	current_frame = num;
}

int CFrameObject::GetMaxFrame()
{
	return images->GetFramesNum(current_image);
}

int CFrameObject::GetFrame()
{
	return current_frame;
}




int CFrameObject::Animation()
{
	current_frame++;
	if(current_frame>=images->GetFramesNum(current_image)) current_frame = 0;
	//printf("[%s]:Animation! frame:%d\n",name,current_frame);
}


int CFrameObject::Show()
{
	if(FLAG & OBJ_NONVISIBLE) return OBJ_NONVISIBLE;
	int sx,sy;
	//printf("[%s]:Show! frame:%d\n",name,current_frame);
	register BITMAP *bmp = images->GetFrame(current_image,current_frame,&sx,&sy);
	if(blend) draw_trans_sprite(p_screen,bmp,x+sx,y+sy);
		else draw_sprite(p_screen,bmp,x+sx,y+sy);
	if(FLAG & OBJ_NONSELECT) return OBJ_NONSELECT;
	if(selected) {
		rect(p_screen,x+sx,y+sy,x+sx+bmp->w,y+sy+bmp->h,makecol(255,0,0));
	}
	return 0;
}

bool CFrameObject::contains(int i_x,int i_y)
{
	int ox,oy;
	int sx,sy;
	register BITMAP *bmp = images->GetFrame(current_image,current_frame,&sx,&sy);
	GetXY(&ox,&oy);
	if((i_x>=ox && i_x<ox+bmp->w) && (i_y>=oy && i_y<oy+bmp->h)) {
		if(Tools::InBitmap(bmp,i_x-ox,i_y-oy)) return true;
	}
	return false;
}

void CFrameObject::SetBlending()
{
	blend = true;
}

extern IObject* gp_cur_object;

int CFrameObject::lua_get_current_frame(lua_State *L)
{
	int n = lua_gettop(L);
	lua_pushnumber(L,((CFrameObject*)gp_cur_object)->GetFrame());
	return 1;
}

