/*
	BetaWorld v 0.1.8
	class for loading Objects and Creatures
*/


#include "object.h"
#include "creature.h" 
#include "objectloader.h"


char *img_name = NULL;
IObject *gp_obj;
ImagesPtrArray *gp_imgs;


CObjectLoader::CObjectLoader():luaScript()
{
	init_script_functions();
}

CObjectLoader::~CObjectLoader()
{
	if(img_name!=NULL) delete[] img_name;
}

IObject* CObjectLoader::Load(char *filename,char *type,char *newname,ImagesPtrArray imgs,IObject *map, int i,int j)
{
	//if(img_name!=NULL) delete[] img_name;
	//img_name = NULL;


	gp_imgs = &imgs;
	
    printf("Allocate object...\n");
	if(!strcmp(type,"object")) {
		gp_obj = new Object();
	}
	if(!strcmp(type,"creature")) {
		gp_obj = new CCreature();
	}

	((Object*)gp_obj)->SetMap(map);


	printf("===>LUA parse file: %s...\n",filename);
	if(lua_dofile(lp_L,filename)==LUA_ERRFILE) {
		printf("ERROR: can't open file: %s\n",filename);
		allegro_exit();
		exit(87);
	}
	printf("===>OK!\n");
    
	

	
	printf("OK!\nSet coords...");
	((Object*)gp_obj)->SetIJ(i,j);
	printf("OK!\nSet object name...");
	gp_obj->SetName(newname);

	printf("OK!\nDestroy temp chars!\n");
	delete[] img_name;
	img_name = NULL;
		
	printf("Return object!\n");
	return gp_obj;
}


void CObjectLoader::init_script_functions()
{
	lua_register(lp_L,"set_object_class_name",set_object_class_name);
	lua_register(lp_L,"set_size",set_size);
	lua_register(lp_L,"set_ImgLib",set_ImgLib);
	lua_register(lp_L,"set_frame",set_frame);
	lua_register(lp_L,"set_blending",set_blending);
	lua_register(lp_L,"set_current_image",set_current_image);
	lua_register(lp_L,"set_flag",set_flag);
	lua_register(lp_L,"set_script",set_script);	
}

int CObjectLoader::set_object_class_name(lua_State *L)
{
	return 0;
}

int CObjectLoader::set_blending(lua_State *L)
{
	((CCreature*)gp_obj)->SetBlending();
	return 0;
}

int CObjectLoader::set_flag(lua_State *L)
{
	int n = lua_gettop(L);
	((Object*)gp_obj)->SetFlag((int)lua_tonumber(L,1));
}


int CObjectLoader::set_size(lua_State *L)
{
	int n = lua_gettop(L);
	int ox = (int)lua_tonumber(L,1);
	int oy = (int)lua_tonumber(L,2); 
	gp_obj->SetSizes(ox,oy);
	return 0;
}



int CObjectLoader::set_frame(lua_State *L)
{
	int n = lua_gettop(L);
	
	((CCreature*)gp_obj)->SetFrame((int)lua_tonumber(L,1));

	return 0;
}

int CObjectLoader::set_script(lua_State *L)
{
	int n = lua_gettop(L);
	
	((Object*)gp_obj)->LoadScript(lua_tostring(L,1));
	return 0;
}


int CObjectLoader::set_current_image(lua_State *L)
{
	int n = lua_gettop(L);
	
	printf("Set current image: %s\n",lua_tostring(L,1));
	((Object*)gp_obj)->SetCurrentImage((char*)lua_tostring(L,1));

	return 0;
}





int CObjectLoader::set_ImgLib(lua_State	*L)
{
	int n = lua_gettop(L);

	if(img_name!=NULL) delete[] img_name;

	img_name = new char[strlen(lua_tostring(L,1))+1];
	strcpy(img_name,lua_tostring(L,1));
	
	//  
    CImgLib *l_img = NULL;
	for(int ci=0;ci<gp_imgs->size();ci++) {
		if(!strcmp((*gp_imgs)[ci]->GetLibName(),img_name)) {
			l_img = (*gp_imgs)[ci];
			break;
		}
	}
	if(l_img==NULL) {
		printf("ERROR: can't find a library: %s\n",img_name);
		allegro_exit();
		exit(30);
	}
	printf("Set object images...");
	((Object*)gp_obj)->SetImages(l_img);
	delete[] img_name;
	img_name = NULL;
	return 0;
}

