#ifndef __SCENE_H
#define __SCENE_H


#include <allegro.h>
#include <vector>

#include "../interfaces/iobject.h"
#include "../tools/imglib.h"
#include "../lua-script/luascript.h"
#include "../system/global.h"



typedef std::vector< IObject* > ObjectPtrArray;



class CScene : public IObject, luaScript {


public:
	CScene();
	CScene(char *name);
	virtual ~CScene();

	virtual int Load(char *filename);
    virtual int Save(char *filename);


    virtual void Move(int ,int);
	virtual void SetXY(int x,int y);
	virtual void GetXY(int*, int*);
	virtual int GetZ() {};


	virtual void SetName(char* name);
	virtual char* GetName();

	virtual int Show();
	virtual int Live();
	virtual int Animation();


	virtual void Add(IObject *obj);
	virtual IObject *Get(char *name);
	virtual IObject *Get(int num);

	virtual void SetScreen(BITMAP* scr);

	virtual void SetSizes(int ,int ) {}
	virtual void GetSizes(int *psx, int *psy) 
	{
		*psx = -1;
		*psy = -1;
	}
	                  
	virtual void SortObjects();
	virtual void SetUpObjectsOnScene();

	virtual void SelectObject(int mx,int my);
	virtual void UnSelectObjects();


	virtual int GetObjectIndex(char *name);

	//virtual int ExecFunction(char *fname,char **argv,int argc);

	virtual int GetType() {return OBJ_SCENE;}

private:
	void CScene::init_script_function();
	static int load_imglib(lua_State *L);
	static int load_object(lua_State *L);
	static int load_creature(lua_State *L);
	static int put_light(lua_State *L);

private:
	BITMAP *buffer;
	ObjectPtrArray objects;
	ObjectPtrArray OnScreen;
	ImagesPtrArray imgs_lib;

	char *name;
};





#endif