#include "imglib.h"
#include "../system/log.h"
#include "tools.h"

#include <allegro.h>
#include <vector>

//#include <conio.h>



extern BITMAP * LoadBitmap(char *filename)
{
	RGB *pal = new RGB[768];
	char buffer[255];
	sprintf(buffer,"Load bitmap: %s...",filename);
	Logger::Log(buffer);
	BITMAP *tmp = load_bitmap(filename,pal);
	delete pal;
	if(tmp!=NULL) Logger::Log("Ok\n"); else Logger::Log("FAIL!\n");

	return tmp;
}


CImgLib::CImgLib():p_name(NULL),return_bitmap(NULL)
{
}

CImgLib::CImgLib(char *filename):p_name(NULL),return_bitmap(NULL)
{
	
}


CImgLib::~CImgLib()
{
	Clear();
	if(p_name!=NULL) delete[] p_name;
	if(return_bitmap!=NULL) destroy_bitmap(return_bitmap);
}

void CImgLib::Clear()
{
	for(int i=lib.size()-1;i>=0;i--) {
		delete lib[i];
		lib.pop_back();
	}
}



int CImgLib::AddToLib(char *filename,char *name,int shift_x,int shift_y)
{
	TLib *l = new TLib();
	l->name = new char[strlen(name)+1];
	strcpy(l->name,name);
	l->shift_x = shift_x;
	l->shift_y = shift_y;

	l->image = LoadBitmap(filename);
	//printf("Push back...");
	lib.push_back(l);
	//printf("OK!\n");

	return lib.size()-1;
}

int CImgLib::AddToLib(char *filename,char *name)
{
	return AddToLib(filename,name,0,0);
}


int CImgLib::Add(BITMAP *bmp,char *pc_name)
{
	TLib* l = new TLib();
	if(l == NULL) {
		printf("\nERROR: can't allocate memory for image library!");
		allegro_exit();
		exit(9);
	}
	int len = strlen(pc_name);
	//printf("Add name: %s  | size: %d\n",pc_name,len);
	//printf("Allocate memory for name...");
	l->name = NULL;
	l->name = new char[len+1];
	if(l->name==NULL) {
		printf("\nERROR: can't allocate memory for name!");
		allegro_exit();
		exit(10);
	}
	//printf("OK\n");
	//printf("STRCPY...");
	strcpy(l->name,pc_name);
	//printf("OK\n");
	l->shift_x = 0;
	l->shift_y = 0;

	l->image = bmp;

	lib.push_back(l);
	return lib.size()-1;
}



BITMAP* CImgLib::Get(unsigned int num)
{
	if (num>lib.size()-1)
	{
		return NULL;
	}
	return lib[num]->image;
}

BITMAP* CImgLib::Get(unsigned int num,int *sx,int *sy)
{
	if (num>lib.size()-1)
	{
		return NULL;
	}
	*sx = lib[num]->shift_x;
	*sy = lib[num]->shift_y;
	return lib[num]->image;
}

void CImgLib::GetShifts(int num,int *sh_x,int *sh_y)
{
	if(num>lib.size()-1) return;
	*sh_x = lib[num]->shift_x;
	*sh_y = lib[num]->shift_y;
}



BITMAP* CImgLib::GetByName(char *name,int *sx,int *sy)
{
	for(unsigned int i=0;i<lib.size();i++)
	{
		if(!strcmp(lib[i]->name,name)) {
			*sx = lib[i]->shift_x;
			*sy = lib[i]->shift_y;
			return lib[i]->image;
		}
	}
	return NULL;
}

BITMAP* CImgLib::GetByName(char *name)
{
	int tx,ty;
	return GetByName(name,&tx,&ty);
}


int CImgLib::GetNum(char *name)
{
	for(unsigned int i=0;i<lib.size();i++)
	{
		if(!strcmp(lib[i]->name,name)) return i;
	}
	return -1;
}


char* CImgLib::GetName(unsigned int num)
{
	if(num>lib.size()-1) return "empty";

	return lib[num]->name;
}

int CImgLib::GetSize()
{
	return lib.size();
}

int CImgLib::Load(char *filename)
{
	FILE *f = fopen(filename,"rb");
	if(f==NULL) return ERROR_OPEN_FILE; 
	char str[255];
	char word[255];
	char i_filename[255];
	char i_name[64];
	int pos=0;
	int off_x,off_y;
	int frame_sx,frame_sy;
	int max_frame;
	//int ret;
	while(!feof(f)) {
		//ret = 
		Tools::get_line(f,str);
		if(str[0]=='#' || str[0]=='\0' || str[0]==0xa || str[0]==0xd) continue;
		Tools::del_spaces(str);
		//printf("READ: [%s]:%d\n",str,strlen(str));
		pos = 0;

		//get path
		pos = Tools::get_word(str,i_filename,'"',pos);
		//printf("path: [%s]\n",i_filename);
		//get name
		pos = Tools::skip_spaces(str,pos);
		pos = Tools::get_word(str,i_name,'"',pos);
		//printf("name: [%s]\n",i_name);
	
		//if is a shift x_y
		//printf("Shift? ");
		pos = Tools::skip_spaces(str,pos);
		if(pos!=-1) {
			//printf("Yes!\n");
			pos = Tools::get_word(str,word,' ',pos);
			off_x = atoi(word);
			//printf("Shift_X: [%d]\n",off_x);
			pos = Tools::skip_spaces(str,pos);
			pos = Tools::get_word(str,word,' ',pos);
			off_y = atoi(word);
			//printf("Shift_Y: [%d]\n",off_y);
		
			//if is frame
			//printf("Frame? ");
			pos = Tools::skip_spaces(str,pos);
			if(pos!=-1) {
				//printf("Yes!\n");
				pos = Tools::get_word(str,word,' ',pos);
				frame_sx = atoi(word);
				//printf("Frame_X: [%d]\n",frame_sx);
				pos = Tools::skip_spaces(str,pos);
				pos = Tools::get_word(str,word,' ',pos);
				frame_sy = atoi(word);
				//printf("Frame_Y: [%d]\n",frame_sy);

				pos = Tools::skip_spaces(str,pos);
				pos = Tools::get_word(str,word,' ',pos);
				max_frame = atoi(word);
				//printf("Frames: [%d]\n",max_frame);

			}
		}
		Logger::Log("--->");
		SetFrameSize(AddToLib(i_filename,i_name,off_x,off_y),frame_sx,frame_sy,max_frame);
		//getch();
	}
	
	fclose(f);
	return 0;
}


void CImgLib::SetLibName(char *pc_name)
{
	p_name = new char[strlen(pc_name)+1];
	strcpy(p_name,pc_name);
}

char* CImgLib::GetLibName()
{
	return p_name;
}


int CImgLib::SetFrameSize(int image_num,int f_sx,int f_sy,int frames)
{
	if(image_num>=lib.size()) return -1;
	//printf("IMAGE NUM: %d\n",image_num);	
	lib[image_num]->frame_sx = f_sx;
	lib[image_num]->frame_sy = f_sy;
	lib[image_num]->frames = frames;

	return 0;	
}

int CImgLib::SetFrameSize(char* image_name,int f_sx,int f_sy,int frames)
{
	for(unsigned int i=0;i<lib.size();i++) {
		if(!strcmp(image_name,lib[i]->name)) {
			SetFrameSize(i,f_sx,f_sy,frames);
			return 0;
		}
	}
	return -1;
}


BITMAP* CImgLib::GetFrame(int image_num,int frame_num,int *shx,int *shy)
{
	if(image_num>=lib.size()) return NULL;
	int sx = lib[image_num]->frame_sx;
	int sy = lib[image_num]->frame_sy;
	*shx = lib[image_num]->shift_x;
	*shy = lib[image_num]->shift_y;
	int x = sx*frame_num;
	if(return_bitmap!=NULL) destroy_bitmap(return_bitmap);
	return_bitmap = create_bitmap(sx,sy);
	blit(lib[image_num]->image,return_bitmap,x,0,0,0,sx,sy);
	return return_bitmap;
}

BITMAP* CImgLib::GetFrame(int image_num,int frame_num)
{
	int a,b;
	return GetFrame(image_num,frame_num,&a,&b);
}
	

BITMAP* CImgLib::GetFrame(char *image_name,int frame_num)
{
	for(unsigned int i=0;i<lib.size();i++) {
		if(!strcmp(image_name,lib[i]->name)) {
			return GetFrame(i,frame_num);
		}
	}
	return NULL;
}


int CImgLib::GetFramesNum(int image_num)
{
	if(image_num>=lib.size()) return -1;
	return lib[image_num]->frames;
}

int CImgLib::GetFramesNum(char *image_name)	
{
	for(unsigned int i=0;i<lib.size();i++) {
		if(!strcmp(image_name,lib[i]->name)) {
			return GetFramesNum(i);
		}
	}
}
