#ifndef __ImageLib_H
#define __ImageLib_H

#include <allegro.h>
#include <string.h>
#include <vector>


#define ERROR_OPEN_FILE		100
#define ERROR_NO_LIST		101


extern BITMAP * LoadBitmap(char *filename);


class TLib
{
public:

	TLib():name(NULL),image(NULL) {};
	~TLib() {
		if(name!=NULL) delete[] name;
		if(image!=NULL) destroy_bitmap(image);
	}
		
	BITMAP *image;
	char *name;
	int shift_x, shift_y;
	int frame_sx,frame_sy;
	int frames;
};


class CImgLib {

typedef std::vector< TLib* > LibPtrArray;
	
public:
	CImgLib();
	CImgLib(char *filename);
	~CImgLib();


	int Add(BITMAP *bmp,char *name);
	int AddToLib(char *filename,char *name);
	int AddToLib(char *filename,char *name,int shift_x,int shift_y);

	BITMAP *Get(unsigned int num);
	BITMAP *Get(unsigned int num,int *,int *);
	BITMAP *GetByName(char *name,int *,int *);
	BITMAP *GetByName(char *name);
	int GetNum(char *name);
	char *GetName(unsigned int num);

	int GetSize();
	void GetShifts(int num,int *sh_x,int *sh_y);

	int Load(char *filename);

	void SetLibName(char *pc_name);
	char *GetLibName();

	int SetFrameSize(int image_num,int f_sx,int f_sy,int frames);
    int SetFrameSize(char* image_name,int f_sx,int f_sy,int frames);

	BITMAP *GetFrame(int image_num,int frame_num);
	BITMAP *GetFrame(char *name,int frame_num);
    BITMAP *GetFrame(int image_num,int frame_num,int *shx,int *shy);
	int GetFramesNum(int image_num);
	int GetFramesNum(char *name);	

	void Clear();


protected:
	LibPtrArray lib;
	char *p_name;
	BITMAP *return_bitmap;
};	


typedef std::vector< CImgLib*  > ImagesPtrArray;




#endif